from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int

Scmap_Scmap_Cell_R_V0_1_0 = CommandToolBuilder(tool="scmap_scmap_cell.R", base_command=["scmap-scmap-cell.R"], inputs=[ToolInput(tag="in_index_object_file", input_type=File(optional=True), prefix="--index-object-file", doc=InputDocumentation(doc="'SingleCellExperiment' object previously prepared with the scmap-index-cluster.R script.")), ToolInput(tag="in_projection_object_file", input_type=File(optional=True), prefix="--projection-object-file", doc=InputDocumentation(doc="'SingleCellExperiment' object to project.")), ToolInput(tag="in_number_nearest_neighbours", input_type=Int(optional=True), prefix="--number-nearest-neighbours", doc=InputDocumentation(doc="A positive integer specifying the number of nearest neighbours to find.")), ToolInput(tag="in_cluster_col", input_type=Int(optional=True), prefix="--cluster-col", doc=InputDocumentation(doc="Column name in the 'colData' slot of the SingleCellExperiment index object containing the cell classification information. If found in the index object, scmapCell2Cluster() will be run to annotate cells of the projection dataset using labels of the reference.")), ToolInput(tag="in_output_object_file", input_type=File(optional=True), prefix="--output-object-file", doc=InputDocumentation(doc="File name in which to store serialized R object of type 'SingleCellExperiment', containing the input object specified by --projection-object-file with cluster labels in its colData (where --cluster-col is set and scmapCell2Cluster() is run).")), ToolInput(tag="in_output_clusters_text_file", input_type=File(optional=True), prefix="--output-clusters-text-file", doc=InputDocumentation(doc="File name in which to text-format cell type assignments.")), ToolInput(tag="in_closest_cells_text_file", input_type=File(optional=True), prefix="--closest-cells-text-file", doc=InputDocumentation(doc="File name in which to store the top cell IDs of the cells of the reference dataset that a given cell of the projection dataset is closest to.")), ToolInput(tag="in_closest_cells_similarities_text_file", input_type=File(optional=True), prefix="--closest-cells-similarities-text-file", doc=InputDocumentation(doc="File name in which to store cosine similarities for the top cells of the reference dataset that a given cell of the projection dataset is closest to."))], outputs=[ToolOutput(tag="out_output_object_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_object_file", type_hint=File()), doc=OutputDocumentation(doc="File name in which to store serialized R object of type 'SingleCellExperiment', containing the input object specified by --projection-object-file with cluster labels in its colData (where --cluster-col is set and scmapCell2Cluster() is run).")), ToolOutput(tag="out_output_clusters_text_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_clusters_text_file", type_hint=File()), doc=OutputDocumentation(doc="File name in which to text-format cell type assignments."))], container="quay.io/biocontainers/scmap-cli:0.0.11--0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Scmap_Scmap_Cell_R_V0_1_0().translate("wdl")

